<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Agent_model extends CI_Model {

	var $table = 'db_agent';
	var $column_order = array('agent','status'); //set column field database for datatable orderable
	var $column_search = array('agent','status'); //set column field database for datatable searchable 
	var $order = array('id' => 'desc'); // default order 

	private function _get_datatables_query()
	{
		
		$this->db->from($this->table);

		$i = 0;
	
		foreach ($this->column_search as $item) // loop column 
		{
			if($_POST['search']['value']) // if datatable send POST for search
			{
				
				if($i===0) // first loop
				{
					$this->db->group_start(); // open bracket. query Where with OR clause better with bracket. because maybe can combine with other WHERE with AND.
					$this->db->like($item, $_POST['search']['value']);
				}
				else
				{
					$this->db->or_like($item, $_POST['search']['value']);
				}

				if(count($this->column_search) - 1 == $i) //last loop
					$this->db->group_end(); //close bracket
			}
			$i++;
		}
		
		if(isset($_POST['order'])) // here order processing
		{
			$this->db->order_by($this->column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
		} 
		else if(isset($this->order))
		{
			$order = $this->order;
			$this->db->order_by(key($order), $order[key($order)]);
		}
	}

	function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		$query = $this->db->get();
		return $query->result();
	}

	function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}

	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}


	public function verify_and_save(){
		//Filtering XSS and html escape from user inputs 
		extract($this->security->xss_clean(html_escape(array_merge($this->data,$_POST))));
		
		//Validate This units already exist or not
		$query=$this->db->query("select * from db_agent where upper(agent)=upper('$agent_name')");
		if($query->num_rows()>0){
			return "This Agent Already Exist.";
			
		}
		else{
			$query1="insert into db_agent(agent,status) 
								values('$agent_name','1')";
			if ($this->db->simple_query($query1)){
					$this->session->set_flashdata('success', 'Success!! Agent Added Successfully!');
			        return "success";
			}
			else{
			        return "failed";
			}
		}
	}

	public function commission_update($data,$sale_itemSet,$return_set){
		//$sale_itemSet = $this->input->post('sale_itemSet');
		$a_count = 0;

		$query=$this->db->insert_batch('db_agent_paymets',$data);

		foreach($sale_itemSet as $id_arry){
            $sale_itm_ID =$id_arry;
			$query1="update db_salesitems set commision_paid = '1' where id = '$sale_itm_ID';";
			if ($this->db->simple_query($query1)){
				$a_count++;
			}
		}

		foreach($return_set as $r_arry){
            $r_ID =$r_arry;
			$query1="update db_return_free set db_return_free.status = '1' where id = '$r_ID';";
			if ($this->db->simple_query($query1)){
			}
		}
		
		return $a_count;
	}

	public function agent_save($agent){
		//Filtering XSS and html escape from user inputs 
		//extract($this->security->xss_clean(html_escape(array_merge($this->data,$_POST))));
		
		//Validate This units already exist or not
		$query=$this->db->query("select * from db_agent where upper(agent)=upper('$agent')");
		if($query->num_rows()>0){
			return "exist";
			//return "This size Name Already Exist.";
			
		}
		else{
			$query1="insert into db_agent(agent,status) 
								values('$agent','1')";
			if ($this->db->simple_query($query1)){
					//$this->session->set_flashdata('success', 'Success!! size Added Successfully!');
			        return "success";
			}
			else{
			        return "failed";
			}
		}
	}

	//Get units_details
	public function get_details($id,$data){
		//Validate This units already exist or not
		$query=$this->db->query("select * from db_agent where upper(id)=upper('$id')");
		if($query->num_rows()==0){
			show_404();exit;
		}
		else{
			$query=$query->row();
			$data['q_id']=$query->id;
			$data['agent']=$query->agent;
			return $data;
		}
	}
	public function update_agent(){
		//Filtering XSS and html escape from user inputs 
		extract($this->security->xss_clean(html_escape(array_merge($this->data,$_POST))));

		//Validate This units already exist or not
		$query=$this->db->query("select * from db_agent where upper(agent)=upper('$agent_name') and id<>$q_id");
		if($query->num_rows()>0){
			return "This agent already Exist.";
			
		}
		else{
			$query1="update db_agent set agent='$agent_name' where id=$q_id";
			if ($this->db->simple_query($query1)){
					$this->session->set_flashdata('success', 'Success!! Agent Updated Successfully!');
			        return "success";
			}
			else{
			        return "failed";
			}
		}
	}
	public function update_status($id,$status){
		
        $query1="update db_agent set status='$status' where id=$id";
        if ($this->db->simple_query($query1)){
            echo "success";
        }
        else{
            echo "failed";
        }
	}
	public function delete_agent($id){
        $query1="delete from db_agent where id=$id";
        if ($this->db->simple_query($query1)){
            echo "success";
        }
        else{
            echo "failed";
        }
	}


}
